#include <stdint.h>


// Seed the state array
static uint32_t  state = 1;

// An algorithm supplied by Chris Doty-Humphrey (Practrand author), user name "scro" on the Parallax forums
// He refered to it as - It doesn't have a name, though it's based upon one of my PRNGs named "rarns"
uint32_t  nextrnd( void )
{
	uint32_t  tmp = state;
	uint32_t  tmp2 = tmp;

	tmp2 ^= tmp2 << 13;
	tmp2 ^= tmp2 >> 17;
	tmp2 ^= tmp2 << 5;
	state = tmp2;

	tmp += (tmp << 18) | (tmp >> 14);  //barrel shift and add
	tmp += ((tmp << 7) | (tmp >> 25)) ^ ((tmp << 11) | (tmp >> 21));  //two barrel shifts, an xor, and an add

	return tmp ^ tmp2;
}
